using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace DrawExtraBorders
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.ColCount = 100;
			this.gridControl1.Location = new System.Drawing.Point(16, 56);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.RowCount = 100;
			this.gridControl1.Size = new System.Drawing.Size(320, 256);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(136, 16);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(368, 334);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form2());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridControl1.CellDrawn += new Syncfusion.Windows.Forms.Grid.GridDrawCellEventHandler(gridControl1_CellDrawn);
		}

		private void gridControl1_CellDrawn(object sender, Syncfusion.Windows.Forms.Grid.GridDrawCellEventArgs e)
		{
			if(e.RowIndex > 0 && e.ColIndex > 0)
			{
				string borders = GetAnySpecialBorders(e.RowIndex, e.ColIndex);
				if(borders.IndexOf("t") > -1)
				{
					e.Graphics.DrawLine(Pens.Blue, e.Bounds.Left, e.Bounds.Top, e.Bounds.Right, e.Bounds.Top);
				}
				if(borders.IndexOf("b") > -1)
				{
					e.Graphics.DrawLine(Pens.Blue, e.Bounds.Left, e.Bounds.Bottom - e.Style.BorderMargins.Bottom - 2, e.Bounds.Right, e.Bounds.Bottom - e.Style.BorderMargins.Bottom - 2);
				}
				if(borders.IndexOf("l") > -1)
				{
					e.Graphics.DrawLine(Pens.Blue, e.Bounds.Left, e.Bounds.Top, e.Bounds.Left, e.Bounds.Bottom);
				}
				if(borders.IndexOf("r") > -1)
				{
					e.Graphics.DrawLine(Pens.Blue, e.Bounds.Right - e.Style.BorderMargins.Right - 2, e.Bounds.Top, e.Bounds.Right - e.Style.BorderMargins.Right - 2, e.Bounds.Bottom);
				}
			}
		}

		GridRangeInfo specialRange = GridRangeInfo.Empty;
		private string GetAnySpecialBorders(int row, int col)
		{
			//used to id special borders - here we hardcode for 
			//a particular range object, but you could do what need to do.
			string borders = "";
			if(specialRange.Contains(GridRangeInfo.Cell(row, col)))
			{
				if(row == specialRange.Top)
					borders = "t";
				if(row == specialRange.Bottom)
					borders += "b";
				if(col == specialRange.Left)
					borders += "l";
				if(col == specialRange.Right)
					borders += "r";
			}
			return borders;
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.specialRange = GridRangeInfo.Cells(2, 2, 4, 5);
			this.gridControl1.RefreshRange(this.specialRange);
		}
	}
}
